.386

.MODEL	FLAT, STDCALL

OPTION	CASEMAP :NONE   ;Case Sensitive

			include MPassword.inc

;;*=====		Main resource declaration	====
IDD_MAIN			EQU		 101
IDD_DLG1			EQU 	102
IDD_DLG2			EQU 	103
IDD_DLG3			EQU 	104

IDC_QUIT			EQU 	1001
IDC_TABCONTROL		EQU 	1002


.CODE


DialogOneProc Proc hWnd:DWORD, uMsg:DWORD,wParam:DWORD,lParam:DWORD
	
	.If uMsg == WM_INITDIALOG
	
	.elseif uMsg == WM_COMMAND
		mov		eax,wParam
		.if ax == IDC_BTNBrowse
			invoke BrowseForFolder,hWnd,ADDR FilePath,ADDR Msg_Browse,ADDR Msg_Folder
		          .if FilePath[0] != 0
	            		invoke	SetDlgItemText,hWnd,IDC_DBPath,Addr FilePath 
            			invoke	SendMessage,hEditPath,WM_SETTEXT,0,Addr FilePath
            		.endif
		.endif
		
		;****	Check for clicked buttons	****
		.if lParam != 0
			;****	Event has happened	****
			.if ax == IDC_BTNAccept
				;*====	Accept button clicked	====
				invoke GetDlgItemText,hWnd,IDC_Pass,ADDR PassWord,63
				invoke GetDlgItemText,hWnd,IDC_SetConfirm,ADDR CPassWord,63

				mov		esi,offset PassWord		; ESI -> password
				mov		edi,offset CPassWord	; EDI -> confirm string
				sub		dx,dx					; case sensitive

				;*====	Compare if the passwords are identical	====
				call	cmp_ASCIIz				; compare the two strings
				
				.if eax == 0
					invoke MessageBox,hWnd,ADDR Msg_PassSame,ADDR AppName,MB_OK
				.else
					invoke MessageBox,hWnd,ADDR Msg_PassDiff,ADDR AppName,MB_OK
				.endif
			.elseif ax == IDC_BTNSave
				;*====	Save configuration button clicked	====
				mov		ax,SAVESYS
				call	ldsv_Sys
			.endif
		.endif 
	.elseif uMsg == WM_CHAR
		mov eax,wParam
		
		.if (al == VK_TAB) || (al == VK_RETURN)
			;*====	Return or TAB key	====
			invoke	GetDlgCtrlID, hWnd
			
			.if ax == IDC_Pass				; password edit control
				invoke	SetFocus,hEd_Pass
			.elseif ax == IDC_SetConfirm	; confirm password edit control
				invoke	SetFocus,hBtnAccept
			.endif
		.endif 
	.Else
		MOV EAX,FALSE
		RET
	.EndIf
	
	MOV EAX,TRUE
	RET

DialogOneProc EndP

DialogTwoProc Proc hWnd:DWORD, uMsg:DWORD,wParam:DWORD,lParam:DWORD
	
	.If uMsg == WM_INITDIALOG
	
	.elseif uMsg == WM_COMMAND
		;*******************************************
		;*===	Check for the various buttons	====
		;*******************************************
		mov		eax,wParam
		.if ax == IDC_BTNAdd
			;****	Add new website information to the database	****
			invoke 	GetDlgItemText,hWnd,IDC_EDTWebsite,ADDR Website,127
			invoke 	GetDlgItemText,hWnd,IDC_EDTURL,ADDR URL,127
			invoke 	GetDlgItemText,hWnd,IDC_EDTUName,ADDR UserName,63
			invoke 	GetDlgItemText,hWnd,IDC_EDTPass,ADDR WebPass,63
			invoke 	GetDlgItemText,hWnd,IDC_EDTRemark,ADDR Remarks,127

			.if (URL[0] != 0) && (UserName[0] != 0) && (WebPass [0] != 0)
				;*====	Check if the website already defined in the database	====
				mov		ecx,WRecords				; load the total record count
				cmp		ecx,0						; no records? 
				je		noWeb						; Yes, insert

				cmp		ecx,MAX_RECORDS			; > allowed record count?
				ja		beyspace						; Yes, then display no space message
								
				mov		esi,offset WData			; ESI -> database
				mov		edx,1						; case insensitive
				mov		edi,offset Website			; EDI -> website name
				sub		ebx,ebx					;
				
				;*====	Search loop	====
			scanlp:
				push	ecx							; save record count
				push	ebx
				
				call		cmp_ASCIIz					; check if the same

				pop		ebx				
				pop		ecx							; restore ECX

				cmp		eax,0						; the same
				je		sameURL					; Yes, prompt
				
				;*====	URL different	====
				push	ecx							; save count
				push	ebx
				push	esi							;  & ESI
				
				;*----		Point to URL name	----
				add		esi,128						; point to URL
				mov		edx,1						; case insensitive
				mov		edi,offset URL					; point to the URL
				
				call		cmp_ASCIIz					; check if the same
				
				pop		esi							; restore ESI
				pop		ebx
				pop		ecx							; restore ECX
				cmp		eax,0						; the same
				je		sameURL					; continue with next record
				
				;*====	Search the next url field	====
			nextRec:
				add		esi,WRecSize				; go to next record's URL
				dec		ecx							; decrement record count
				jne		scanlp						;
				
				;*====	Save the website record information into the database	====
			noWeb:
				call		Add_WRec					; insert new record into the database
				call		dsp_lview					; display the new inserted record
       				invoke	SendMessage,hStatus,SB_SETTEXT,0,offset Msg_Buf
				mov		[bChanged],1				; set database changed flag
				invoke	SetDlgItemInt,hWnd,IDC_EDTCount,WRecords,0
				invoke	SetDlgItemInt,hWnd,IDC_EDTRecNo,WCurIndex,0
				jmp		noAdd						; exit
				
				;*====	Display no memory for new records	====
			beyspace:
				invoke	SendMessage,hStatus,SB_SETTEXT,0,offset Msg_No_Space
				jmp		noAdd						; exit

				;*====	Same URL found	====
			sameURL:
				mov		[WCurIndex],ebx				; save current index
				invoke 	MessageBox,hWnd,ADDR Msg_DupURL,ADDR AppName,MB_YESNO
				
				cmp		eax,IDYES					; insert into database
				je		noWeb						; continue

				invoke 	MessageBox,hWnd,ADDR Msg_NoAdd,ADDR AppName,MB_OK
				invoke	show_Rec,hTabDlg[4]			; display unchanged record 
			.else
	       			invoke	SendMessage,hStatus,SB_SETTEXT,0,offset Msg_InvData
			.endif

			noAdd: 			
		.elseif ax == IDC_BTNDel
			;****	Delete current website information from the database	****
			cmp		[WRecords],0					; there are records to delete
			je		NoRecDel						; No records to delete
			
			call	Del_WRec						; delete current record
		NoRecDel:
		.elseif ax == IDC_BTNUp
			;****	Go to previous website information to the database	****
			cmp		[WCurIndex],0					; check if at top of database
			je		atTop							; already at top
	
			;*====	Copy the data in database into memory for display	====
			dec		[WCurIndex]						; decrement index record
		showRec:	 
			invoke	show_Rec,hWnd					; 
		atTop:
		.elseif ax == IDC_BTNDown
			;****	Go to next website information to the database	****
			mov		eax,[WCurIndex]					; EAX = current index number
			inc		eax								; adjust for one based
			cmp		eax,[WRecords]					; reached the bottom of database?
			jae		atBottom						; Yes, ignore
			
			inc		[WCurIndex]						; increment record index
			jmp		showRec	
		atBottom:									; 
		.elseif ax == IDC_BTNTop
			;****	Go to the top record website information to the database	****
			mov		[WCurIndex],0					; reset to 1st record
			jmp		showRec							; 
		.elseif ax == IDC_BTNBottom
			;****	Go to the last website information to the database	****
			mov		eax,[WRecords]					; get total record count
			dec		eax								; adjust for zero based
			mov		[WCurIndex],eax					; save the index record number
			jmp		showRec							;
		.elseif ax == IDC_BTNWCopy					; copy URL name into clipboard
			invoke	SendMessage,hURL,EM_SETSEL,0,-1	;
			invoke	SendMessage,hURL,WM_COPY,0,0
       		invoke	SendMessage,hStatus,SB_SETTEXT,0,offset Msg_WName_Copy
		.elseif ax == IDC_BTNUCopy					; copy user name into clipboard
			invoke	SendMessage,hUserName,WM_COPY,0,0
       		invoke	SendMessage,hStatus,SB_SETTEXT,0,offset Msg_UName_Copy
		.endif 
	.Else
		MOV EAX,FALSE
		RET
	.EndIf
	
	MOV EAX,TRUE
	RET

DialogTwoProc EndP

DialogThreeProc Proc hWnd:DWORD, uMsg:DWORD,wParam:DWORD,lParam:DWORD
  			LOCAL 	lvc:LV_COLUMN 
	
	.If uMsg == WM_INITDIALOG
	
		invoke GetDlgItem,hWnd,IDC_LSVPass		; listview control
		mov		[hListView],eax

		;*====	Call routine to create the columns in the listview control	====
		invoke	InsertColumn,hListView 

		;*====	Set up the header	====
		invoke 	SendMessage,hListView,LVM_GETHEADER, 0, 0   ;// get handle to header 
		mov 	hHeader,eax   						;// preserve header handle 
		invoke 	GetWindowLong, hHeader, GWL_STYLE   ;// get current window styles 
		xor 	eax,HDS_BUTTONS 
		invoke 	SetWindowLong,hHeader, GWL_STYLE, eax   ;// set the new header styles 
	
		;/* Setup extended styles like gridlines, back-foregroundcolors */
		mov   	 eax, LVS_EX_FULLROWSELECT or LVS_EX_HEADERDRAGDROP or LVS_EX_SUBITEMIMAGES or LVS_EX_GRIDLINES

		invoke   SendMessage, hListView, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, eax
		invoke   SendMessage, hListView, LVM_SETTEXTCOLOR, 0, 00000000h
		invoke   SendMessage, hListView, LVM_SETBKCOLOR, 0, 00FFFFFFh
		invoke   SendMessage, hListView, LVM_SETTEXTBKCOLOR, 0,00A6F7F0h
		
		;*====	Display the partial data covered in a listview columns	====
		;invoke SendMessage, hwnd, LVM_SETEXTENDEDLISTVIEWSTYLE, LVS_EX_LABELTIP, LVS_EX_LABELTIP
	.elseif uMsg == WM_ACTIVATE
		mov		eax,wParam
		.if WRecords > 0 && ax == WA_ACTIVE
			call		dsp_db_lview				; display 
		.endif
	.elseif uMsg == WM_COMMAND
		;*******************************************
		;*===	Check for the various buttons	====
		;*******************************************
		mov		eax,wParam
		.if ax == IDC_BTNRefresh
			call		dsp_db_lview				; display 
			invoke	show_Rec,hTabDlg[4]
		.endif
	.elseif uMsg == WM_NOTIFY
		mov 	edi,lParam
		mov		eax,[edi].NMHDR.code
		.if eax == NM_DBLCLK
			invoke 	SendMessage,hListView,LVM_GETNEXTITEM,-1,LVNI_FOCUSED
			cmp		eax,-1
			je		noindex		

			mov		[WCurIndex],eax
			invoke	show_Rec,hTabDlg[4]
	noindex:
		.endif
	.Else
		MOV EAX,FALSE
		RET
	.EndIf
	
	MOV EAX,TRUE
	RET

DialogThreeProc EndP

DlgProc	Proc hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
		Local	 TCItem	:TC_ITEM

	.If uMsg == WM_INITDIALOG
		MOV		 TCItem.imask,TCIF_TEXT or TCIF_PARAM
		MOV 	TCItem.cchTextMax,64
		
		;2
		Invoke CreateDialogParam,hInstance,IDD_DLG3,hWnd,Offset DialogThreeProc,0
		mov 		hTabDlg[8],eax
		MOV 	TCItem.pszText,Offset TabTitle3
		MOV 	TCItem.lParam,EAX
		Invoke 	SendDlgItemMessage,hWnd,IDC_TABCONTROL,TCM_INSERTITEM,0,ADDR TCItem
		
		;1
		Invoke 	CreateDialogParam,hInstance,IDD_DLG2,hWnd,Offset DialogTwoProc,0
		mov 		hTabDlg[4],eax
		MOV 	TCItem.pszText,Offset TabTitle2
		MOV 	TCItem.lParam,EAX
		Invoke 	SendDlgItemMessage,hWnd,IDC_TABCONTROL,TCM_INSERTITEM,0,ADDR TCItem
		
		
		;0
		Invoke CreateDialogParam,hInstance,IDD_DLG1,hWnd,Offset DialogOneProc,0
		mov 		hTabDlg,eax
		MOV 	TCItem.pszText,Offset TabTitle1
		MOV 	TCItem.lParam,EAX
		
		;Store handle of the visible child dialog
		Invoke 	SetWindowLong,hWnd,GWL_USERDATA,TCItem.lParam
		
		Invoke 	SendDlgItemMessage,hWnd,IDC_TABCONTROL,TCM_INSERTITEM,0,ADDR TCItem
		Invoke 	SendDlgItemMessage,hWnd,IDC_TABCONTROL,TCM_SETCURSEL,0,0
		Invoke 	SetWindowPos,TCItem.lParam,HWND_TOP,0,0,0,0,SWP_SHOWWINDOW or SWP_NOMOVE or SWP_NOSIZE
		
		;*====	Get application path name	====
		invoke 	GetAppPath, offset FilePath
				
		invoke GetDlgItem,hWnd,IDC_DBPath		; database path edit control
		mov		[hEditPath],eax

		invoke GetDlgItem,hWnd,IDC_BTNBrowse	; database path edit control
		mov		[hBtnBrowse],eax

		invoke GetDlgItem,hWnd,IDC_Pass			; password edit control
		mov		[hEd_Pass],eax
	
		invoke GetDlgItem,hWnd,IDC_SetConfirm	; confirm password edit control
		mov		[hEd_Confirm],eax		

		invoke GetDlgItem,hWnd,IDC_BTNSave		; save configuration button control
		mov		[hSaveConf],eax		

		invoke GetDlgItem,hWnd,IDC_BTNAccept	; password button control
		mov		[hBtnAccept],eax		

		invoke GetDlgItem,hWnd,IDC_EDTURL		; URL edit control
		mov		[hURL],eax		

		invoke GetDlgItem,hWnd,IDC_EDTUName		; username edit control
		mov		[hUserName],eax		

		invoke GetDlgItem,hWnd,IDC_SBR1			; statusbar
		mov		[hStatus],eax

		mov		ax,LOADSYS
		call		ldsv_Sys
			
		.if eax == 0
;			invoke MessageBox,hWnd,ADDR Msg_SysLdOK,ADDR AppName,MB_OK
				
			.if WRecords != 0
				mov		ax,LOADDB				; get load database command code
				call		ldsv_DB					;
				invoke	show_Rec,hTabDlg[4]		;
				call		dsp_db_lview

				;*====	Display the record count	====
	       			invoke SendMessage,[hStatus],SB_SETTEXT,0,offset Msg_SysLdOK
			.endif
		.elseif eax > 3
			invoke MessageBox,hWnd,ADDR Msg_SysLdErr,ADDR AppName,MB_OK
		.endif
	
		mov		[bChanged],0					; reset database changed flag
;		invoke 	SendMessage,[hStatus],SB_SETTEXT,0,offset Msg_Welcome

;	.elseif uMsg == WM_ACTIVATE
;		.if WRecords != 0
;			invoke	show_Rec,hTabDlg[4]			;
;			call		dsp_db_lview
;		.endif
	.elseif uMsg == WM_GETDLGCODE
	.ElseIf uMsg == WM_NOTIFY
		MOV EDX, lParam
		
		.If [EDX].NMHDR.code == TCN_SELCHANGE
			
			Invoke GetWindowLong,hWnd,GWL_USERDATA
			Invoke ShowWindow,EAX,SW_HIDE
			
			Invoke SendDlgItemMessage,hWnd,IDC_TABCONTROL,TCM_GETCURSEL,0,0
			MOV TCItem.imask,TCIF_PARAM
			MOV EDX,EAX
			Invoke SendDlgItemMessage,hWnd,IDC_TABCONTROL,TCM_GETITEM,EDX,ADDR TCItem
			
			Invoke SetWindowLong,hWnd,GWL_USERDATA,TCItem.lParam
			
			;Invoke ShowWindow,TCItem.lParam,SW_SHOW
;			@@:
			Invoke SetWindowPos,TCItem.lParam,HWND_TOP,0,0,0,0,SWP_SHOWWINDOW or SWP_NOMOVE or SWP_NOSIZE
			
		.EndIf
		
	.ElseIf	uMsg == WM_COMMAND
		mov		eax,wParam
		mov		edx,eax
		and		eax,0FFFFh
		shr		edx,16

		.If	wParam == IDC_QUIT
			
			Invoke EndDialog,hWnd,0
			
		.EndIf
		
		.if edx==BN_CLICKED
			;*====	Exit if Quit button is clicked	====
			.if eax==IDQuit
				invoke SendMessage,hWnd,WM_CLOSE,0,0
			.elseif eax==IDDone
				;*====	Save system records first	====
				.if bChanged != 0
					;call	save_DB						; save database
					mov		ax,SAVEDB				; save database command code
					call		ldsv_DB					;

;					mov		edi,offset FPath			; EDI -> working path
;					mov		esi,offset FilePath			; ESI -> file path
;					mov		ebx,offset Sys_FileName		; EBX -> system record file name
;;					call	save_Sys					;  & system record

					mov		ax,SAVESYS			; save system record
					call		ldsv_Sys
					.if eax == 0
						invoke MessageBox,hWnd,ADDR Msg_SysWrOK,ADDR AppName,MB_OK
	       					invoke SendMessage,hStatus,SB_SETTEXT,0,offset Msg_SysWrOK
					.else
						invoke MessageBox,hWnd,ADDR Msg_SysWrErr,ADDR AppName,MB_OK
       						invoke SendMessage,hStatus,SB_SETTEXT,0,offset Msg_SysWrErr
					.endif
					mov		[bChanged],0				; reset database changed
				.endif
	
				invoke SendMessage,hWnd,WM_CLOSE,0,0
			.elseif eax==IDM_HELP_ABOUT
				invoke MessageBox,hWnd,ADDR Msg_Welcome,ADDR AppName,MB_OK
			.endif
		.endif

		;****	Check for menu command	====
		.if ax == IDM_FILE_SAVEDB
			;****	Save the database	****
;			mov		esi,offset FilePath			; file path
;			mov		edi,offset FPath			; working path
;			mov		ebx,offset DB_FileName		; database filename
;			call		combine_path_file			; concentanate file name, path into working path
;
;			mov		ebx,offset FPath			; file path
;			mov		edi,offset WData			; EDI -> database
;			mov		eax,WRecords				; record count
;			mov		bx,WRecSize
;			mul		bx
;			mov		ecx,eax						; ECX = bytes to save
;
;			call	save_File						; save the database
			mov		eax,SAVEDB				; 
			call		ldsv_DB					; save database
			
			mov		eax,SAVESYS				; 
			call		ldsv_Sys					; save system record
			
			.if eax != 0
				;*====	Error in saving database
				.if eax == -1
					invoke MessageBox,hWnd,ADDR Msg_WriteOErr,ADDR AppName,MB_OK
				.elseif eax == -2
					invoke MessageBox,hWnd,ADDR Msg_WriteNErr,ADDR AppName,MB_OK
				.elseif eax == -3
					invoke MessageBox,hWnd,ADDR Msg_WriteWErr,ADDR AppName,MB_OK
				.endif
			.else
				invoke MessageBox,hWnd,ADDR Msg_WriteOK,ADDR AppName,MB_OK
			.endif	
		.elseif ax == IDM_FILE_LOADDB
			;****	Load the database	****
;			mov		esi,offset FilePath			; file path
;			mov		edi,offset FPath			; working path
;			mov		ebx,offset DB_FileName		; database filename
;			call		combine_path_file			; concentanate file name, path into working path
;			
;			;*====	
;			mov		ebx,offset FPath			; file path
;			mov		edi,offset WData			; EDI -> database
;			mov		eax,WRecords				; record count
;			mov		bx,WRecSize
;			mul		bx
;			mov		ecx,eax						; ECX = bytes to save
;
;			call		load_File						; save the database
			mov		eax,LOADDB
			call		ldsv_DB					; 
			
			.if eax != 0
				;*====	Error in saving database
				.if eax > 3 
					invoke MessageBox,hWnd,ADDR Msg_LoadErr,ADDR AppName,MB_OK
				.endif
			.else
				invoke MessageBox,hWnd,ADDR Msg_LoadOK,ADDR AppName,MB_OK
			.endif	
		.elseif ax == IDM_FILE_LOADSYS
			;****	Load the system record	****
			mov		ax,LOADSYS
			call		ldsv_Sys
		.elseif ax == IDM_FILE_SAVESYS
			;****	Save the system record	****
			mov		ax,SAVESYS
			call		ldsv_Sys
		.endif
	.elseif eax==WM_KEYUP
				invoke MessageBox,hWnd,ADDR Msg_LoadOK,ADDR AppName,MB_OK
	.ElseIf	uMsg == WM_CLOSE
		
		Invoke	EndDialog,hWnd,0
		
	.EndIf

	XOR	EAX,EAX
	RET
DlgProc	EndP


Start:

	Invoke	GetModuleHandle, NULL
	MOV	hInstance, EAX
	Invoke InitCommonControls
	Invoke	DialogBoxParam, hInstance, IDD_MAIN, 0, ADDR DlgProc, 0
	Invoke	ExitProcess, EAX


;*==================================================================================*
;*			Routine to setup the environment for this programm to work				*
;*==================================================================================*
init_Wallet	proc	hWin:HWND
			;*====	Get handle to TAB 1 controls	****	
;			call	load_Sys						; save the system record
			mov		ax,LOADSYS
			call	ldsv_Sys
			
			.if eax == 0
				invoke MessageBox,hWin,ADDR Msg_SysLdOK,ADDR AppName,MB_OK
				
				.if WRecords != 0
					mov		ax,LOADDB				; get load database command code
					call		ldsv_DB					;
					invoke	show_Rec,hWin			;

					;*====	Display the record count	====
					invoke	SetDlgItemInt,hWin,IDC_EDTCount,WRecords,0
					invoke	SetDlgItemInt,hWin,IDC_EDTRecNo,WCurIndex,0
				.endif
			.elseif eax > 3
				invoke MessageBox,hWin,ADDR Msg_SysLdErr,ADDR AppName,MB_OK
			.endif
	
			mov		[bChanged],0					; reset database changed flag
	       		invoke 	SendMessage,hStatus,SB_SETTEXT,0,offset Msg_Welcome

			ret

init_Wallet endp

;*==================================================================================*
;*			Routine to clear the listview control									*
;*==================================================================================*
clr_lview	proc
	
			invoke	SendMessage,hListView,LVM_DELETEALLITEMS,0,0	
			ret

clr_lview 	endp

;*==================================================================================*
;*			Routine to insert the new website record into the listview				*
;*==================================================================================*
dsp_lview	proc	
			;*====	Prepare to insert a new row	====
			mov 		lvi.imask,LVIF_TEXT+LVIF_PARAM	; preset the listview to text parameters
			mov		eax,[WCurIndex]					; get row number
			mov 		lvi.iItem,eax					; insert the row number
			mov	 	lvi.lParam,eax					; set the user value
			mov 		lvi.iSubItem,0					; 1st field 
			mov 		lvi.pszText,offset Website		; website name 
			invoke 	SendMessage, hListView, LVM_INSERTITEM,0, addr lvi

			;*====	Insert the next column - URL	----			
			mov 		lvi.imask,LVIF_TEXT				; preset the listview to text parameters
			mov 		lvi.iSubItem,01					; field #1
			mov 		lvi.pszText,offset URL			; ptrs to URL
			invoke 	SendMessage, hListView, LVM_SETITEM,0, addr lvi
				
			mov 		lvi.iSubItem,02					; field #2
			mov 		lvi.pszText,offset UserName		; ptrs to user name
			invoke 	SendMessage, hListView, LVM_SETITEM,0, addr lvi

			mov 		lvi.iSubItem,03					; field #3
			mov 		lvi.pszText,offset WebPass		; ptr to password
			invoke 	SendMessage, hListView, LVM_SETITEM,0, addr lvi
	
			ret

dsp_lview 	endp

;*==================================================================================*
;*			Routine to display the whole database in listview						*
;*==================================================================================*
dsp_db_lview proc	
			invoke	SendMessage,hListView,LVM_DELETEALLITEMS,0,0	

			mov		ecx,WRecords					; ECX = record count
			mov		[WCurIndex],0					; set current index to 1st record 
			
			.repeat
				push	ecx							; save count
				call	GetWRecord					; 
				call	dsp_lview					; display record
				inc		[WCurIndex]					; increment index
				pop		ecx
				dec		ecx
			.until ecx == 0
			
			dec		[WCurIndex]						; re-adjust to last index
			
			ret

dsp_db_lview endp


;****=======================================================================****
;****			Routine to compare two strings case sensitive null string	****
;****-----------------------------------------------------------------------****
;****			Input:	ESI -> String 1										****
;****					EDI -> String 2										****
;****					DX =  0 case sensitive, 1 = case insensitive		****					
;****																		****
;****			Output:	EAX = 0	Same										****
;****						= 1 Different									****
;****																		****
;****			Registers preserved:	ESI, EDI							****
;****			Registers corrupted:	EAX									****
;****=======================================================================****
cmp_ASCIIz	proc
			push	esi						; save ESI
			push	edi						;  & EDI
			
			;*====	Setup environment for compare	====
		cmplp:
			mov		al,[esi]				; get character
			cmp		al,0					; null character?
			je		cmpsame					; Yes, then string 
			
			mov		ah,[edi]				; get string 2 character
			cmp		al,0					; null character?
			je		cmpdiff					; Yes, then exit
			
			cmp		dx,0					; case sensitive?
			je		cmpcase					; Yes, do case sensitive
			
			and		ax,5F5Fh				; make it case insensitive

			;*====	Compare characters	====
		cmpcase:
			cmp		al,ah					; same?
			jne		cmpdiff					; No, different
			
			;*====	Go to next character	====
			inc		esi						; increment pointers
			inc		edi						;
			jmp		cmplp					;
			
			;*====	Restore stack	====
		cmpex:
			pop		edi						; restore EDI
			pop		esi						;  & ESI
			ret

			;*====	Strings are different	====
		cmpdiff:
			mov		eax,1					; return different status
			jmp		cmpex					; Exit
			
			;*====	Check if 2nd string also EOS	====
		cmpsame:
			mov		ah,[edi]				; get string 2 character
			cmp		al,0					; null character?
			jne		cmpdiff					; No, then string is different
			
			sub		eax,eax					; string is the same
			jmp		cmpex					; exit
cmp_ASCIIz 	endp

;*==================================================================================*
;*			Routine to get the string length of a string (ASCIIz string)			*
;*----------------------------------------------------------------------------------*
;*			This routine will determine the length of the ASCIIz string.			*
;*																					*
;*			Input:  ESI -> Source buffer											*
;*																					*
;*			Output:	ECX = String length	(one based)									*
;*==================================================================================*
get_strlen		proc
				push	esi						; save ptr
				sub		ecx,ecx					; reset ECX
		getstrlp:
				cmp		byte ptr [esi],0		; ASCIIz character?
				je		getstrex				; Yes, then exit
				
				inc		ecx						; increment length
				inc		esi						;  & ptr
				jmp		getstrlp				; continue till ASCIIz character is found

		getstrex:
				pop		esi						;
				ret
get_strlen		endp

;*==================================================================================*
;*			Routine to copy ASCIIz string from source to destination				*
;*----------------------------------------------------------------------------------*
;*			Routine to copy the source string into the destination and 				*
;*			register are not preserved												*
;*																					*
;*			Input:	ESI -> Source string											*
;*					EDI -> Destination buffer										*
;*																					*
;*			Output:	ECX = String length copied										*
;*==================================================================================*
copy_null	proc
			mov		al,[esi]					; get character
			cmp		al,00						; null character
			je		copyNex						; Yes, then exit
			
			mov		[edi],al					; save character in destination  buffer
			inc		ecx							; increment ECX
			inc		esi							; increment pointers
			inc		edi
			jmp		copy_null					; copy  				
	
			;*====	Restore pointers	====
		copyNex:
			ret

copy_null 	endp

;*==================================================================================*
;*			Routine to copy ASCIIz string from source to destination				*
;*----------------------------------------------------------------------------------*
;*			Input:	ESI -> Source string											*
;*					EDI -> Destination buffer										*
;*					ECX = Start destination string length							*
;*																					*
;*			Output:	ECX = String length copied										*
;*==================================================================================*
copy_ASCIIz	proc
			push	esi							; save pointers
			push	edi							;
			
			;*====	Copy string	====
		copylp:
			mov		ah,al						; copy previous character in AL
			mov		al,[esi]					; get character
			cmp		al,00						; null character
			je		copyex						; Yes, then exit
			
			mov		[edi],al					; save character in destination  buffer
			inc		ecx							; increment ECX
			inc		esi							; increment pointers
			inc		edi
			jmp		copylp						; copy  				
	
			;*====	Restore pointers	====
		copyex:
			mov		byte ptr [edi],0			; terminate 
			pop		edi
			pop		esi
			ret
copy_ASCIIz endp

;*==================================================================================*
;*			Routine to concatenate two strings										*
;*----------------------------------------------------------------------------------*
;*			This routine will save the database 							  		*
;*																					*
;*			Input:  EDI -> Main string												*
;*					ESI -> String 2 to write into main string 						*
;*																					*
;*			Output:	EAX = 	0 OK													*
;*							-1 Error												*
;*==================================================================================*
concatASCIIz proc
			;*====	Move pointer to end of ASCIIz string	====
		movelp:
			cmp		byte ptr [edi],00				; check if end of string
			je		endStr							; Yes, done
			
			inc		edi								; increment pointer
			jmp		movelp							; continue
			
			;*====	End of string reached. Copy the rest	====
		endStr:		
			call	copy_ASCIIz						; copy the second string into main string
			ret

concatASCIIz endp	


;*==================================================================================*
;*			Routine to concatenate a file name into file path						*
;*----------------------------------------------------------------------------------*
;*			This routine will save the database 							  		*
;*																					*
;*			Input:  EDI -> Main buffer												*
;*					ESI -> File name				 								*
;*																					*
;*			Output:	ECX = Main string length used									*
;*																					*
;*			Registers corrupted: EDI, ESI											*
;*==================================================================================*
concat_File	proc
			push	edi								; save the main buffer
			
			sub		ecx,ecx							; reset ECX
			sub		eax,eax							; reset EAX

			;*====	Move pointer to end of ASCIIz string	====
		movelp:
			cmp		byte ptr [edi],00				; check if end of string
			je		cendStr							; Yes, done

			mov		al,[edi]						; get the character before EOS			

			inc		ecx								; increment count
			inc		edi								; increment pointer
			jmp		movelp							; continue
			
			;*====	End of string reached. Copy the rest	====
		cendStr:
			cmp		al,5Ch							; last character a path delimiter?
			je		delimt							; Yes, then ignore adding one
					
			mov		byte ptr [edi],5Ch				; include the 
			inc		ecx								; increment length
			inc		edi								; increment ptr
		delimt:
			call	copy_ASCIIz						; copy the file name
			
			pop		edi								; restore the pointer	
			ret

concat_File endp

;*==================================================================================*
;*			Routine to concatenate path, file name into file path					*
;*----------------------------------------------------------------------------------*
;*			This routine will save the database 							  		*
;*																					*
;*			Input:  EDI -> Main string												*
;*					ESI -> Path name				 								*
;*					EBX -> File name												* 					
;*																					*
;*			Output:	ECX = Main string length used									*
;*																					*
;*			Registers corrupted: EDI, ESI											*
;*==================================================================================*
combine_path_file proc
			sub		ecx,ecx						; reset start length
			call	copy_ASCIIz					; copy into path into working path

			mov		esi,ebx						; system filename
			call	concat_File					; concentanate file name into path

			ret

combine_path_file endp

;*==================================================================================*
;*			Routine to fetch the record from the database into memory buffer		*
;*----------------------------------------------------------------------------------*
;*			This routine will save all the website information and save it  		*
;*			into the database.														*
;*																					*
;*			Input:  WCurIndex variables (zero based)								*
;*																					*
;*			Output:	Website information will be updated								*
;*==================================================================================*
GetWRecord	proc
			mov		bx,WRecSize					; get record byte size
			mov		eax,WCurIndex				;  & record index
			mul		bx							; EAX = offset
			mov		esi,offset WData			; ESI -> wallet database
			add		esi,eax						; ESI -> record
			
			mov		edi,offset Website			;  
			call	copy_ASCIIz					; copy website name into record
			
			add		esi,128						; skip to next field
			mov		edi,offset URL				; ESI -> URL address
			call	copy_ASCIIz					; copy URL field into record
			
			add		esi,128						; skip to next field
			mov		edi,offset UserName			; ESI -> user name
			call	copy_ASCIIz					; copy URL field into record
			
			add		esi,64						; skip to next field
			mov		edi,offset WebPass			; ESI -> password
			call	copy_ASCIIz					; copy URL field into record
			
			add		esi,64						; skip to next field
			mov		edi,offset Remarks			; ESI -> remark
			call	copy_ASCIIz					; copy URL field into record

			ret
GetWRecord endp

;*==================================================================================*
;*			Routine to display current website record in Tab 2 controls				*
;*==================================================================================*
show_Rec	proc	hWin:DWORD
			invoke	SetDlgItemInt,hWin,IDC_EDTCount,WRecords,0
			invoke	SetDlgItemInt,hWin,IDC_EDTRecNo,WCurIndex,0
;			invoke	SetDlgItemInt,hWin,IDC_STCCount,WRecords,0
;			invoke	SetDlgItemInt,hWin,IDC_STCRecNo,WCurIndex,0

			call	GetWRecord					; get current web record
			
			invoke	SetDlgItemText,hWin,IDC_EDTWebsite,offset Website	
			invoke	SetDlgItemText,hWin,IDC_EDTURL,offset URL	
			invoke	SetDlgItemText,hWin,IDC_EDTUName,offset UserName	
			invoke	SetDlgItemText,hWin,IDC_EDTPass,offset WebPass	
			invoke	SetDlgItemText,hWin,IDC_EDTRemark,offset Remarks
			ret

show_Rec endp

;*==================================================================================*
;*			Routine to get the add the record into the database						*
;*----------------------------------------------------------------------------------*
;*			This routine will save all the website information and save it  		*
;*			into the database.														*
;*																					*
;*			Input:  Website variables 												*
;*																					*
;*			Output:	WRecords, WData, WCurIndex will be updated						*
;*==================================================================================*
Add_WRec	proc
			mov		edi,offset WData			; ESI -> wallet database
			mov		ebx,WRecSize				; record byte size
			mov		eax,[WRecords]				; EAX = total record count

			cmp		eax,0						; any record defined?
			je		NoRec						; No, then continue
			
			mul		bx							; get record offset 
		NoRec:
			add		edi,eax						; EDI -> next free location
			
			;*====	Clear the destination buffer first	====
			push	edi							; save pointer
			
			mov		ecx,WRecSize				; ECX =record byte size
			sub		al,al						; clear AL
			rep		stosb						; 
			
			pop		edi							; restore EDI
			
			;*====	Copy each field into database field	====
			mov		esi,offset Website			;  
			call	copy_ASCIIz					; copy website name into record
			
			add		edi,128						; skip to next field
			mov		esi,offset URL				; ESI -> URL address
			call	copy_ASCIIz					; copy URL field into record
			
			add		edi,128						; skip to next field
			mov		esi,offset UserName			; ESI -> user name
			call	copy_ASCIIz					; copy URL field into record
			
			add		edi,64						; skip to next field
			mov		esi,offset WebPass			; ESI -> password
			call	copy_ASCIIz					; copy URL field into record
			
			add		edi,64						; skip to next field
			mov		esi,offset Remarks			; ESI -> remark
			call	copy_ASCIIz					; copy URL field into record
			
			mov		eax,[WRecords]				; get current record index
			mov		[WCurIndex],eax				; make it current
			inc		eax							; increment total record count
			mov		[WRecords],eax				; save the record count
			
			;*====	Setup display buffer for display	====
			mov		ecx,63						;
			sub		eax,eax
			mov		edi,offset Msg_Buf			; EDI -> buffer to display message
			rep		stosd						; clear display buffer
			
			mov		edi,offset Msg_Buf			; EDI -> buffer to display message
			mov		esi,offset Col_Website		; ESI -> website message
			call	copy_null					; copy website msg
			mov		byte ptr [edi],3Ah			; insert ":"
			mov		byte ptr [edi+1],20h		; insert space
			mov		byte ptr [edi+2],27h		; insert "'"
			add		edi,3						; update ptr
			mov		esi,offset Website			; ESI -> point to website name
			call	copy_null					; copy into display buffer
			mov		byte ptr [edi],27h			; insert "'"
			inc		edi
			mov		esi,offset Msg_Ins			; ESI -> inserted message
			call	copy_null					; copy into display buffer
			
			mov		byte ptr [edi],0			; insert null character
			
			ret
Add_WRec 	endp

;*==================================================================================*
;*			Routine to get the add the record into the database						*
;*----------------------------------------------------------------------------------*
;*			This routine will save all the website information and save it  		*
;*			into the database.														*
;*																					*
;*			Input:  WCurIndex variables - current record index						*
;*																					*
;*			Output:	WRecords, WData, WCurIndex will be updated						*
;*==================================================================================*
Del_WRec	proc
			mov		eax,WRecords				; EAX = total records in database
			sub		eax,WCurIndex				; EAX = Total - current = number of records to move
			mov		edx,eax						; copy into EDX 
			dec		eax							; adjust for zero based index
			mov		ebx,WRecSize				; record byte size
			
			mul		bx							;
			
			;*====	Number of bytes to move into deleted area	====  
			mov		ecx,eax						; ECX = number of bytes to move
			 	
			mov		eax,edx						; current record index
			mul		bx							; EAX = offset to current record 		
			mov		esi,offset WData			; ESI -> wallet database
			add		esi,eax						; point to start of record
			mov		edi,esi						; copy into EDI
			add		esi,WRecSize				; go to next record
			
			cld									; downward direction
			rep		movsb						; copy data

			dec		WRecords					; decrement total record
			
			mov		eax,WCurIndex				; EAX = current record
			cmp		eax,WRecords				; current index record out of database?
			jb		DelRex						; No, then continue
			
			;*====	Ensure current index record is within the database	====  
			mov		eax,WRecords				; get total record 
			dec		eax
			mov		WCurIndex,eax				;
		DelRex: 
			call	GetWRecord					; display new record 
			ret

Del_WRec 	endp

;*==================================================================================*
;*			Routine to get the save a data											*
;*----------------------------------------------------------------------------------*
;*			This routine will save the database 							  		*
;*																					*
;*			Input:  EBX -> File path												*
;*					EDI -> Database 												*
;*					ECX = Bytes to save												*
;*																					*
;*			Output:	EAX = 	0 OK													*
;*							-1 Error												*
;*==================================================================================*
save_File		proc
			push	edi							; save registers
			push	ecx							;
										
			invoke	CreateFile, ebx, GENERIC_WRITE, FILE_SHARE_READ, 0, \
					CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0

			cmp		eax,INVALID_HANDLE_VALUE 	; does the file exits?
			je		savedberr			 		;
			
			mov		[hFile],eax					; save file handle
			
			pop		ecx							; restore byte to save
			pop		edi							; pointer to database
			
			push	ecx							; save size
			 
			;*----	WriteFile, hFile, Buffer, Bytes to save, bytes saved	----
			invoke	WriteFile, eax, edi, ecx, offset i_byteread, 00

			pop		ecx							; ECX = bytes to save
			cmp		ecx,[i_byteread]			; same number of bytes saved
			jne		savedb_byterr				; number of bytes saved error
			
			cmp		eax,FALSE					; save OK?
			je		writeError					; No, error
			
			invoke	CloseHandle, hFile			; close file
			sub		eax,eax						; return OK status
		saveEx:
			pop		edi
			ret

			;*====	Error opening file for write	====
		savedberr:
			mov		eax,-1						;return error
		saveErrCode:
			push	eax							; save return code
			
			invoke	CloseHandle, hFile			; close file
       	    invoke	GetLastError				;
       	    mov		[FileError],eax
       	    
       	    pop		eax							; get return code back
			jmp		saveEx

			;*====	Error in byte written count	====
		savedb_byterr:
			mov		eax,-2						;return error
			jmp		saveErrCode
		
			;*====	Unable to save file	====
		writeError:
			mov		eax,-3						;return error
			jmp		saveErrCode
		
save_File 	endp

;*==================================================================================*
;*			Routine to get the load a database										*
;*----------------------------------------------------------------------------------*
;*			This routine will load the database 							  		*
;*																					*
;*			Input:  EBX -> File path												*
;*					EDI -> Database 												*
;*					ECX = Bytes to load												*
;*																					*
;*			Output:	EAX = 	0 OK													*
;*							-1 Error												*
;*==================================================================================*
load_File		proc
			push	edi
			push	ecx
	
			;*====	Open file for read operation	====
			invoke	CreateFile, ebx, GENERIC_READ, FILE_SHARE_READ, 0, \
					OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0

			cmp		eax,INVALID_HANDLE_VALUE ; does the file exits?
			je		loadDBerr				 ;
					
			;*----	Valid file and is to be read	-----
			mov		[hFile],eax				; save file handle

			pop		ecx						; restore read byte count
			pop		edi						;  & destination buffer
			
			push	ecx						; save count again for use later
			
			;*----	Read the whole file into file buffer	----
			;*----	ReadFile, hFile, lpBuffer, NoofBytesToRead, NoofBytesRead, lpOverlapped
			invoke	ReadFile, hFile, edi, ecx, offset i_byteread, 00
				
			cmp		eax,FALSE				; read operation error
			je		loadDBerr				; process error

			invoke	CloseHandle, hFile		; close file
			sub		eax,eax					; done

			;*====	Prepare to exit - restore stack	====
	loadEx:
			pop		ecx
			pop		edi
			ret

	loadDBerr:
			invoke	CloseHandle, hFile		; close file
			mov		eax,-1					; error loading file
       	    invoke	GetLastError			;
			jmp		loadEx
load_File 	endp

;*==================================================================================*
;*			Routine to get the load/save the database								*
;*----------------------------------------------------------------------------------*
;*			Input:	AX 	= 1  Load database											*
;*						= 2	 Save database											*
;*==================================================================================*
ldsv_DB		proc
			push	ax							; save command code
			
			mov		esi,offset FilePath			; file path
			mov		edi,offset FPath			; working path
			mov		ebx,offset DB_FileName		; database filename
			call	combine_path_file			; concentanate file name, path into working path

			mov		ebx,edi						; EDI -> database path name
			mov		edi,offset WData			; EDI -> database
			mov		eax,[WRecords]				; get record count
			mov		ecx,WRecSize				; record count
			mul		cx							; 
			mov		ecx,eax						; byte count to save 

			pop		ax							; restore command code
			.if ax == LOADDB
				call	load_File				; load database
			.else
				call	save_File				; save database
			.endif
		
			ret

ldsv_DB 	endp

;*==================================================================================*
;*			Routine to get the load system record									*
;*==================================================================================*
;save_DB		proc
;			mov		esi,offset FilePath			; file path
;			mov		edi,offset FPath			; working path
;			mov		ebx,offset DB_FileName		; database filename
;			call	combine_path_file			; concentanate file name, path into working path
;
;			mov		ebx,edi						; EDI -> database path name
;			mov		edi,offset WData			; EDI -> database
;			mov		eax,[WRecords]				; get record count
;			mov		ecx,WRecSize				; record count
;			mul		cx							; 
;			mov		ecx,eax						; byte count to save
;
;			call	save_File					; save database
;		
;			ret
;
;save_DB 	endp

;*==================================================================================*
;*			Routine to get the load system record									*
;*----------------------------------------------------------------------------------*
;*			Input:	AX 	= 1  Load system record										*
;*						= 2	 Save system record										*
;*==================================================================================*
ldsv_Sys	proc
			push	ax
			mov		edi,offset FPath			; working path
			sub		eax,eax						;
			mov		ecx,64
			rep		stosd						; clear the destination buffer
			
			mov		esi,offset FilePath			; file path
			mov		edi,offset FPath			; working path
			mov		ebx,offset Sys_FileName		; system filename
			call	combine_path_file			; concentanate file name, path into working path

			mov		ebx,edi			
			mov		edi,offset WRecords			; EDI -> database
			mov		ecx,320						; record count

			pop		ax
			.if ax == LOADSYS
				call	load_File				; load system record
			.else
				call	save_File				; save system record				
			.endif
		
			ret

ldsv_Sys 	endp

;*==================================================================================*
;*			Routine to get the load system record									*
;*==================================================================================*
save_Sys	proc
			mov		edi,offset FPath			; working path
			sub		eax,eax						;
			mov		ecx,64
			rep		stosd						; clear the destination buffer
			
			mov		esi,offset FilePath			; file path
			mov		edi,offset FPath			; working path
			mov		ebx,offset Sys_FileName		; system filename
			call	combine_path_file			; concentanate file name, path into working path

			mov		ebx,edi			
			mov		edi,offset WRecords			; EDI -> database
			mov		ecx,320						; record count

			call	save_File						; save the database
			
			ret

save_Sys 	endp

;*==============================================================================*
;*			Routine to insert the columns into the listview control				*
;*==============================================================================*
InsertColumn proc	hwnd:DWORD
  			LOCAL 	lvc:LV_COLUMN 
  			
  			mov 	lvc.imask,LVCF_TEXT+LVCF_WIDTH 
  			mov 	lvc.pszText,offset Col_Website
  			mov 	lvc.lx,200 
  			invoke 	SendMessage,hwnd, LVM_INSERTCOLUMN, 0, addr lvc

  			or 		lvc.imask,LVCF_FMT
  			mov 	lvc.fmt,LVCFMT_LEFT 
  			mov 	lvc.pszText,offset Col_URL 
  			mov 	lvc.lx,200
  			invoke 	SendMessage,hwnd, LVM_INSERTCOLUMN, 1 ,addr lvc 

  			mov 	lvc.pszText,offset Col_User
  			mov 	lvc.lx,150
  			invoke 	SendMessage,hwnd, LVM_INSERTCOLUMN, 2 ,addr lvc 

  			mov 	lvc.pszText,offset Col_Pass
  			mov 	lvc.lx,150
  			invoke 	SendMessage,hwnd, LVM_INSERTCOLUMN, 3 ,addr lvc 

	  		ret 
InsertColumn endp

; #########################################################################

;*==================================================================================*
;*			Routine to convert binary into decimal ASCII characters	in string buffer*
;*----------------------------------------------------------------------------------*
;*			This routine will convert binary into decimal ASCII characters.			*
;*																					*
;*			Input:  EAX = Binary													*
;*					EDI -> Source buffer											*
;*					ECX = Number of digits to display								*
;*					Carry = 1, insert null character								*
;*																					*
;*			Registers changed: EDI, ECX												*
;*==================================================================================*
cnv_bin_dstr		proc
					;*====	Write spaces to the digit places	====
					push	ecx						; save string length
					push	eax						;  & binary value
					pushf							; save flag

					mov		al,20h					; AL = space
					rep		stosb					; write spaces into it
					
					popf							; restore ASCIIz string type flag
					jnc		cnvbind					; non-ASCIIz string
					
					mov		byte ptr [edi],0		; insert null character
					
			cnvbind:
					pop		eax						; restore binary value
					pop		ecx
					dec		edi						; adjust for 1 based offset
					
					;*====	Check if binary value is zero	====
					cmp		eax,00					; value is zero?
					jne		cnvbindon				; No, then convert
					
					mov		byte ptr [edi],30h		; indicate a zero value
					jmp		appnddsD
					
					;*====	Convert to ASCII	====
			cnvbindon:
					mov		bx,10					; divisor
			appndds:
					sub		edx,edx					; reset EDX
					cmp		eax,0					; conversion completed
					je		appnddsD				; Yes, continue
			
					;*----	Convert into decimal	----
					div		bx						; AX/BX
					add		dl,30h					; convert to ASCII code
					mov		[edi],dl				; 
					dec		edi						;
					dec		cl						; decrement digit count
					jne		appndds					;
					
					;*====	Check the flag	====
			appnddsD:
					ret								; conversion done
cnv_bin_dstr		endp


;*==================================================================================*
;*			Routine to encrypt a string with a simple encruption					*
;*----------------------------------------------------------------------------------*
;*			Input:	ESI -> String to be encrypted									*
;*					EDI -> Password string											*
;*					EBX -> Destination buffer to store encrypted string				*
;*					Both strings are ASCIIz string type								*
;*==================================================================================*
encrypt_strs		proc
					push	ebp						;
					push	edx						; save the required use registers
					push	ecx						; 
					push	ebx
	
					;*====	Get the lengths of the strings first	====
					call	get_strlen				;
					push	esi						; save ESI
					mov		edx,ecx					;  & length in EDX
					
					mov		esi,edi					; password string
					call	get_strlen				; get ASCIIz string length
					
					pop		edi						; EDI -> string to be encrypted
					
					;*====	Perform the encryption	====
					sub		ebp,ebp					; reset EBP
			encryptlp:
					mov		al,[edi]				; character from string to be encrypted
					mov		ah,al					; copy into AH
					shr		ax,4					; swap nybble
					
					mov		ah,[esi+ebp]			; AH = character from password string
					xor		al,ah					; XORed the character
					mov		[ebx],al				; save the encrypted password
					
					inc		ebx						; increment destination ptr
					inc		ebp						; increment password offset
					cmp		ebp,ecx					; reached the password string length
					jne		noreset					; No, continue
					
					sub		ebp,ebp					; Yes, then reset the password offset
			noreset:
					dec		edx						; decrement string to be encrypted length
					jne		encryptlp				; continue  
	
					;*====	Restore the registers and stack	====
					pop		ebx
					pop		ecx
					pop		edx
					pop		ebp
					ret

encrypt_strs 		endp

;*==================================================================================*
;*			Routine to encrypt a string with a simple encruption					*
;*----------------------------------------------------------------------------------*
;*			Input:	ESI -> String to be encrypted									*
;*					EDI -> Password string											*
;*					EBX -> Destination buffer to store encrypted string				*
;*					Both strings are ASCIIz string type								*
;*==================================================================================*
unencrypt_strs		proc
					push	ebp						;
					push	edx						; save the required use registers
					push	ecx						; 
					push	ebx
	
					;*====	Get the lengths of the strings first	====
					call	get_strlen				;
					push	esi						; save ESI
					mov		edx,ecx					;  & length in EDX
					
					mov		esi,edi					; password string
					call	get_strlen				; get ASCIIz string length
					
					pop		edi						; EDI -> string to be encrypted
					
					;*====	Perform the encryption	====
					sub		ebp,ebp					; reset EBP
			unencryptlp:
					mov		al,[edi]				; get character from string to be uncrypted
					mov		ah,[ebx+ebp]			; AH = character from password string
					xor		al,ah					; XOR it
					mov		ah,al					; copy into AH
					shr		ax,4					; swap byte
					
					mov		[ebx],al				; save uncrypted character
					inc		ebx						; increment destination ptr
					
					inc		ebp						; increment password offset
					cmp		ebp,ecx					; reached the password string length
					jne		unoreset				; No, continue
					
					sub		ebp,ebp					; Yes, then reset the password offset
			unoreset:
					dec		edx						; decrement string to be encrypted length
					jne		unencryptlp				; continue  
	
					;*====	Restore the registers and stack	====
					pop		ebx
					pop		ecx
					pop		edx
					pop		ebp
					ret
			
unencrypt_strs		endp



End Start
